Subject: Re: [IPROUTE PATCH] iproute2: act_ipt fix xtables breakage on older versions.

From: Stephen Hemminger <[email-masked]>
Date: Thu, 25 Apr 2013 16:16:24 -0700

On Thu, 25 Apr 2013 15:07:16 -0700
Alexander Duyck <[email-masked]> wrote:

> In trying to build on a RHEL6.3 I ran into several build issues that are
> addressed in this patch.
> 
> The first is that xtables_options_xfrm only has 3 options.  It appears this is
> how this code was originally.  As such for the case where the version is less
> than 6 I am assuming it would be correct to maintain the original setup that
> only had 3 parameters being passed instead of 4.
> 
> I also ran into an issue with the define for __ALIGN_KERNEL not being present.
> I believe this may be due to the fact that __ALIGN_KERNEL was moved into a
> separate header from ALIGN after the uapi changes.  In order to just cover all
> of the bases I have moved the main definition for the macros into
> __ALIGN_KERNEL_MASK and __ALIGN_KERNEL and if ALIGN is also needed then it is
> just a direct redefine to __ALIGN_KERNEL.
> 
> Cc: Hasan Chowdhury <[email-masked]>
> Cc: Jamal Hadi Salim <[email-masked]>
> Signed-off-by: Alexander Duyck <[email-masked]>

I want some feedback from Jamal and libxt netfilter experts.
This code has been fragile in the past.